/*******************************************************************************
 *
 * File Name: olc.h
 * Author: Richard Baxter
 * Project: Optional Line Creator
 * Project Version: 1b9a 12-June-07
 * Comments: this olc.cpp contains code from sprite.cpp from LRRC 2c4a (24-Feb-07)
 *
 *******************************************************************************/

#include "referenceClass.h"

#define OPTIONAL_LINE_DATA_HEADER "0 \n0 Optional Line Data (generated using OLC.exe):\n0 \n"

#ifdef WANT_ADDITIONAL_OPT_LINES_FOR_LDVIEW_RENDERING
	#define NO_COLINEAR_OLS_CHECK
#endif

int main();

bool createPartWithOptionalLines();

bool partOptionalLinesFileOutput(char * partFileModifiedName, char * partFileOriginalName, Reference * initialReferenceInPart);

/***************************** PART 1 ***********************************************/
void createReferenceListOfOptionalLines(Reference * initialReferenceInPart, Reference * initialReferenceInOptionalLineData);
	Reference * addOptionalLineReferencesForQuad(Reference * quadReference, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInPart, Reference * initialReferenceInOptionalLineData, bool * result);
	Reference * addOptionalLineReferencesForTri(Reference * triReference, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInPart, Reference * initialReferenceInOptionalLineData, bool * result);
		Reference *  findCorrespondingPrimRefEdgeAndAddOptionalLine(int polyReferenceEdgeNumber, vec * polyReferenceVertexA, vec * polyReferenceVertexB, Reference * polyReferenceFull, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInPart, Reference * initialReferenceInOptionalLineData, bool * result);
			Reference * fillOptionalLine(int polyReferenceEdgeNumber, vec * polyReferenceVertexA, vec * polyReferenceVertexB, Reference * polyReferenceFull, Reference * currentReferenceInPart, Reference * currentReferenceInOptionalLineData, Reference * initialReferenceInOptionalLineData, int currentReferenceInPartEdgeNumber, bool * result);
				bool edgeLinesVerticiesAndOLVerticsOnSamePlane(vec* edgeLineVertex1, vec* edgeLineVertex2, vec* optionalLineVertex1, vec* optionalLineVertex2);
					void find2DIntersectionPoint(double ax, double ay, double bx, double by, double cx, double cy, double dx, double dy, double * intersectionX, double * intersectionY, bool * interceptionFound, bool * interceptionPointFound);	//NB an interception may be a line and not a point
						double calcDistanceBetweenTwoPoints2D(double x1, double y1, double x2, double y2);
						bool solve2DLineEquationWithTwoPoints(double x1, double y1, double x2, double y2, double * m, double * i);
						bool determineIfPointLiesOnLine2D(double x1, double y1, double x2, double y2, double x3, double y3);
						bool find2DIntersectionPointOfTwoLines(double m1, double i1, double m2, double i2, double * xIntersection, double * yIntersection);
						bool twoPointsAreTheSame2D(double x1, double y1, double x2, double y2);
						bool determineIfPointLiesOnAKnownLine2D(double m1, double i1, double x3, double y3);

//these should be shifted elsewhere
Reference * search2DRefListRemoveRef(Reference * referenceToFindAndRemove, Reference * initialReferenceInList, bool * result);
Reference * search2DRefListRemoveAnyLikeOptionalLineRef(Reference * referenceToFindAndRemove, Reference * initialReferenceInList, bool * result);
bool search2DRefListFindAnyLikeOptionalLineRef(Reference * referenceToFind, Reference * initialReferenceInList);
bool compareAnyLikeOptionalLineReferences(Reference * reference1, Reference * reference2);


