/*******************************************************************************
 *
 * File Name: referenceManipulation.h
 * Author: Richard Baxter
 * Project: Generic Ldraw Construct Functions
 * Project Version: 2d11a 3-June-07
 *
 *******************************************************************************/


#ifndef HEADER_REFERENCEMANIPULATION
#define HEADER_REFERENCEMANIPULATION

#include "referenceClass.h"

#define DAT_FILE_GENERIC_MAX_SIZE (10000000)		//10MB - the maximum size of any ldraw .DAT/.LDR file

/*currently shared routines*/



bool search2DRefListFindRef(Reference * referenceToFind, Reference * initialReferenceInList);		//not currently used
bool search2DRefListNameAndColourFindRef(Reference * referenceToFind, Reference * initialReferenceInList);
bool search2DRefListReplaceRef(Reference * referenceToFind, Reference * referenceToReplaceWith, Reference * initialReferenceInList);	//not currently used
bool search2DRefListNameAndColourReplaceRef(Reference * referenceToFind, Reference * referenceToReplaceWith, Reference * initialReferenceInList);
bool search2DReferenceListAddReference(Reference * initialReferenceInList, Reference * referenceToAdd);
bool compareReferenceNameAndColour(Reference * reference, const char * referenceName, int referenceColour);
void copyReferences(Reference * referenceNew, Reference * referenceToCopy, int type);
void copyReferencesAndSubmodelDetails(Reference * referenceNew, Reference * referenceToCopy, int type);		//not currently used
bool compareReferences(Reference * reference1, Reference * reference2, int type);


void addNewLineCharacterToString(char * string);
void addSpaceCharacterToString(char * string);
void convertPositionCoordinatesToString(vec * spriteSceneCoords, char * string);
bool writeReferencesToFile(char * fileName, Reference * firstReference);
bool convertReferencesToByteArray(Reference * firstReference, char * fileByteArray, int * fileByteArraySize);
bool convertReferenceToString(Reference * currentReference, char * submodelReferenceString);
void writeFile(char * sceneFileName, char * sceneFileByteArray, int sceneFileByteArraySize);
bool readFile(char * sceneFileName, char * sceneFileByteArray, int * sceneFileNumberOfLines, int * sceneFileByteArraySize);
void copyFiles(char * newFileName, char * fileToCopyName);

/*sprite routines*/
void convertRotationMatrixToString(mat * rotationMatrix, char * string);
bool findTextInByteArray(char * byteArray, int byteArraySize, char * searchString, int searchStringLength, int * lineNumberOfReference);	//OLD
bool addLinesToByteArray(char * byteArray, char * lineByteArray, int * byteArraySize, int lineByteArraySize, int lineNumberToAdd);	//OLD
bool replaceLinesInByteArray(char * byteArray, char * lineByteArray, int * byteArraySize, int lineByteArraySize, int lineNumberToReplace, int numberOfLinesToReplace);	//OLD


#endif
