/*******************************************************************************
 *
 * File Name: vector.h
 * Author: Richard Baxter
 * Project: Generic Ldraw Construct Functions
 * Project Version: 2d11a 3-June-07
 *
 *******************************************************************************/


#ifndef HEADER_VECTOR
#define HEADER_VECTOR

#include "referenceClass.h"

#define PI (3.1416)

bool compareDoubles(double a, double b);
bool compareVectors(vec * veca, vec * vecb);
bool compareMatricies(mat * mata, mat * matb);
void copyVectors(vec * vecNew, vec * vecbToCopy);
void copyMatricies(mat * matNew, mat * matToCopy);
void subtractVectors(vec * vecNew, vec * a, vec * b);

void createRotationxMatrix(mat* matrix, double rotation);
void createRotationyMatrix(mat* matrix, double rotation);
void createRotationzMatrix(mat* matrix, double rotation);
double convertDegreesToRadian(double degrees);
//void rotateMatrix(mat * matrix, char rotationAxis, double rotationDegrees);
void createIdentityMatrix(mat* matx);
void copyMatrix2IntoMatrix1(mat* mat1, mat* mat2);
void scaleMatrix(mat * matrix, double scaleFactor);
void createRotatationMatrix(mat * matrix, char rotationAxis, double rotationDegrees);

#endif




